function [C] = q2_nml_constant(n)

    % We compute the elements of the sums in log-space in order to
    % avoid Matlab's warnings about bad precision for binomial
    % coefficients. The terms for k=0 and k=n take the value 1.
    C = 2;
    for k = 1:(n-1)
        tmp = gammaln(n+1) - gammaln(k+1) - gammaln(n-k+1) ...
              + k*log(k/n) + (n-k)*log(1-k/n);
        C = C + exp(tmp);
    end
    
end