function [codelen] = q2_o1(D)

    if not (isrow(D))
        error('D must be a row vector');
    end
    
    n = [ 0, 0 ];
    k = [ 0, 0 ];
    
    for i = 2:length(D)
        prev = D(i-1) + 1;
        if D(i) == 0
            k(prev) = k(prev) + 1;
        end
        n(prev) = n(prev) + 1;
    end
    
    theta = k ./ n;
    C = [ q2_nml_constant(n(1)), q2_nml_constant(n(2)) ];
    
    codelen = 1;
    for i = 1:2
        codelen = codelen - k(i)*log2(theta(i)) ...
                          - (n(i)-k(i))*log2(1-theta(i)) ...
                          + log2(C(i));
    end
    
end