function [codelen] = q2_o2(D)

    if not (isrow(D))
        error('D must be a row vector');
    end
    
    n = [ 0, 0, 0, 0 ];
    k = [ 0, 0, 0, 0 ];
    
    for i = 3:length(D)
        prev = 2*D(i-2) + D(i-1) + 1;
        if D(i) == 0
            k(prev) = k(prev) + 1;
        end
        n(prev) = n(prev) + 1;
    end
        
    theta = k ./ n;
    C = [ q2_nml_constant(n(1)), q2_nml_constant(n(2)), ...
          q2_nml_constant(n(3)), q2_nml_constant(n(4)) ];
    
    codelen = 2;
    for i = 1:4
        codelen = codelen - k(i)*log2(theta(i)) ...
                          - (n(i)-k(i))*log2(1-theta(i)) ...
                          + log2(C(i));
    end
    
end